//braille script
module braille(dot1,dot2,dot3,dot4,dot5,dot6)
{translate([0,0,4.8]) sphere(d=dot1*1.55,$fn=50);
translate([0,0,2.4]) sphere(d=dot2*1.55,$fn=50);
translate([0,0,0]) sphere(d=dot3*1.55,$fn=50);
translate([2.4,0,4.8]) sphere(d=dot4*1.55,$fn=50);
translate([2.4,0,2.4]) sphere(d=dot5*1.55,$fn=50);
translate([2.4,0,0]) sphere(d=dot6*1.55,$fn=50);}
//braille(0,0,0,0,0,0);
//Space between cells: (6-7 mm)
//Space between lines: 10mm (10-11mm)
//https:brailleaustralia.org/about-braille/physical-specifications-for-braille/
cellspace=6.2;
linespace=10;

module braille_char(char) {
    if (char == "a") {
        braille(1,0,0,0,0,0);}
    else if (char == "b") {
        braille(1,1,0,0,0,0);}
    else if (char == "c") {
        braille(1,0,0,1,0,0);}
    else if (char == "d") {
        braille(1,0,0,1,1,0);}
    else if (char == "e") {
        braille(1,0,0,0,1,0);}
    else if (char == "f") {
        braille(1,1,0,1,0,0);}
    else if (char == "g") {
        braille(1,1,0,1,1,0);}
    else if (char == "h") {
        braille(1,1,0,0,1,0);}
    else if (char == "i") {
        braille(0,1,0,1,0,0);}
    else if (char == "j") {
        braille(0,1,0,1,1,0);}
    else if (char == "k") {
        braille(1,0,1,0,0,0);}
    else if (char == "l") {
        braille(1,1,1,0,0,0);}
    else if (char == "m") {
        braille(1,0,1,1,0,0);}
    else if (char == "n") {
        braille(1,0,1,1,1,0);}
    else if (char == "o") {
        braille(1,0,1,0,1,0);}
    else if (char == "p") {
        braille(1,1,1,1,0,0);}      
    else if (char == "q") {
        braille(1,1,1,1,1,0);}         
    else if (char == "r") {
        braille(1,1,1,0,1,0);}         
    else if (char == "s") {
        braille(0,1,1,1,0,0);}         
    else if (char == "t") {
        braille(0,1,1,1,1,0);}         
    else if (char == "u") {
        braille(1,0,1,0,0,1);} 
    else if (char == "v") {
        braille(1,1,1,0,0,1);} 
    else if (char == "w") {
        braille(0,1,0,1,1,1);} 
    else if (char == "x") {
        braille(1,0,1,1,0,1);}         
    else if (char == "y") {
        braille(1,0,1,1,1,1);}         
    else if (char == "z") {
        braille(1,0,1,0,1,1);}
//strong contractions        
        else if (char == "and") {
        braille(1,1,1,1,0,1);}  
        else if (char == "for") {
        braille(1,1,1,1,1,1);}
        else if (char == "of") {
        braille(1,1,1,0,1,1);}
        else if (char == "the") {
        braille(0,1,1,1,0,1);}
        else if (char == "with") {
        braille(0,1,1,1,1,1);}  
//strong groupsigns
        else if (char == "ch") {
        braille(1,0,0,0,0,1);}
        else if (char == "gh") {
        braille(1,1,0,0,0,1);}
        else if (char == "sh") {
        braille(1,0,0,1,0,1);}
        else if (char == "th") {
        braille(1,0,0,1,1,1);}
        else if (char == "wh") {
        braille(1,0,0,0,1,1);}       
        else if (char == "ou") {
        braille(1,1,0,0,1,1);}
        else if (char == "st") {
        braille(0,0,1,1,0,0);}
        else if (char == "ed") {
        braille(1,1,0,1,0,1);}
        else if (char == "er") {
        braille(1,1,0,1,1,1);}
        else if (char == "ow") {
        braille(0,1,0,1,0,1);}
        else if (char == "ar") {
        braille(0,0,1,1,1,0);}
        else if (char == "ing") {
        braille(0,0,1,1,0,1);} 
//lower groupsigns
        else if (char == "ea") {
        braille(0,1,0,0,0,0);}
        else if (char == "bb") {
        braille(0,1,1,0,0,0);}
        else if (char == "cc") {
        braille(0,1,0,0,1,0);}
        else if (char == "ff") {
        braille(0,1,1,0,1,0);}
        else if (char == "gg") {
        braille(0,1,1,0,1,1);} 
        else if (char == "be") {
        braille(0,1,1,0,0,0);}  
        else if (char == "con") {
        braille(0,1,0,0,1,0);} 
        else if (char == "dis") {
        braille(0,1,0,0,1,1);}
        else if (char == "en") {
        braille(0,1,0,0,0,1);} 
        else if (char == "in") {
        braille(0,0,1,0,1,0);}
//punctuation and other
        else if (char == "cap") {
        braille(0,0,0,0,0,1);}
        else if (char == "'") {
        braille(0,0,1,0,0,0);}
        else if (char == ",") {
        braille(0,1,0,0,0,0);}
        else if (char == ".") {
        braille(0,1,0,0,1,1);}
        else if (char == "dot5") {
        braille(0,0,0,0,1,0);}
        else if (char == "dot45") {
        braille(0,0,0,1,1,0);}
        else if (char == "dot46") {
        braille(0,0,0,1,0,1);}
        else if (char == "dot56") {
        braille(0,0,0,0,1,1);}
        else if (char == "dot456") {
        braille(0,0,0,1,1,1);} 
        else if (char == "#") {
        braille(0,0,1,1,1,1);}
        else if (char == "-") {
        braille(0,0,1,0,0,1);   }     
        }
        
module braille_str(chars, char_count){
    for (count = [0:char_count-1]) {
	translate(v = [count * cellspace, 0,0]) {
       braille_char(chars[count]);
			}}}
//Include the following to put the braille into your file
//chars = ["c","u","c","u","m","b","er"];
//char_count=7;
//braille_str(chars, char_count);